ARG BUILD_IMAGE=

FROM ${BUILD_IMAGE}

ARG DOCKER_BUILDTAGS="include_oss include_gcs continuous_profiler_stackdriver"
ARG REGISTRY_VERSION=v4.17.0-gitlab
ARG REGISTRY_NAMESPACE=gitlab-org
ARG REGISTRY_PROJECT=container-registry
ARG GOPATH=/go
ARG REGISTRY_SOURCE_PATH=${GOPATH}/src/github.com/docker/distribution

ENV GOTOOLCHAIN=local

ADD gitlab-go.tar.gz /

RUN mkdir -p /assets/usr/local \
    && ln -sf /usr/local/go/bin/* /usr/local/bin \
    && git clone https://gitlab.com/${REGISTRY_NAMESPACE}/${REGISTRY_PROJECT}.git \
      --branch ${REGISTRY_VERSION} --single-branch ${REGISTRY_SOURCE_PATH} \
    && cd ${REGISTRY_SOURCE_PATH} \
    && mkdir /assets/licenses \
    && cp LICENSE /assets/licenses/GitLab.txt \
    && CGO_ENABLED=0 BUILDTAGS=${DOCKER_BUILDTAGS} make clean binaries \
    && cp -R bin/ /assets/usr/local
